qutip-jax: JAX backend for QuTiP
================================

A plug-in for [QuTiP](https://qutip.org) providing a [JAX](https://github.com/google/jax) linear-algebra backend.
Backing the linear algebra operations with JAX extends QuTiP's
capability to work with a GPU. Furthermore, it allows QuTiP's `Qobj` class to
benefit from [auto differentiation](https://jax.readthedocs.io/en/latest/notebooks/autodiff_cookbook.html).

We are actively developing the plug-in and in the pre-alpha state. Therefore it is a work-in-progress and is not ready for use yet. You are welcome to contribute or take part in the development by posting issues, PRs and through discussions.

Documentation
-------------
https://qutip-jax.readthedocs.io/en/latest/index.html

Support
-------

[![Unitary Fund](https://img.shields.io/badge/Supported%20By-UNITARY%20FUND-brightgreen.svg?style=flat)](https://unitary.fund)
[![Powered by NumFOCUS](https://img.shields.io/badge/powered%20by-NumFOCUS-orange.svg?style=flat&colorA=E1523D&colorB=007D8A)](https://numfocus.org)

We are proud to be affiliated with [Unitary Fund](https://unitary.fund) and
[NumFOCUS](https://numfocus.org).  QuTiP development is supported by [Nori's
lab](https://dml.riken.jp/) at RIKEN, by the University of Sherbrooke, and by
Aberystwyth University, [among other supporting
organizations](https://qutip.org/#supporting-organizations).


Contact
-------
Contact Shahnawaz Ahmed (shahnawaz.ahmed95@gmail.com), Eric Giguère(eric.giguere@calculquebec.ca) or anyone from the QuTiP admin team (https://qutip.org/devs.html) for more information.
